commit 03f112e25525985c1b8e758ae17fd90589430d6b
Author: Varun Nagaraju <varun.nagaraju@percona.com>
Date:   Thu Oct 31 16:21:08 2024 +0530

    PS-9434 FTS cleanup on DROP INDEX issue when adding a FULLTEXT index in same transaction
    
    https://perconadev.atlassian.net/browse/PS-9434
    
    Bug#36559642
    mysql/mysql-server@5484c73368a
    mysql/mysql-server@a8b3732507e
    mysql/mysql-server@c25f8c03be8
    
    Cause:
    When all FULLTEXT indexes are dropped from a table, but another one
    is added in the same transaction using INPLACE algorithm, the logic for
    dropping the last FULLTEXT index performs cleanup on the assumption
    that the in-memeory and on-disk FTS infrastructure is not needed any
    more. Because of the way the INPLACE algorithm works, creation of said
    infrastructure for the index being added and related checks will have
    already been done at this point - the index is already added but not
    yet published (the in-memory fts_t structure is not updated) and thus
    not detected. This leaves the infrastructure in an inconsistent state,
    leading to incorrect behavior.
    
    Fix:
    When dropping a FULLTEXT index, do not perform the cleanup if another
    FULLTEXT index is to be added in the same transaction.
    
    Test case added.
    
    Change-Id: Iceed9f4c755d2cd44d2cf7b301fc0f3a18a521cc

diff --git a/mysql-test/suite/innodb_fts/r/innobase_create_after_drop_fts_index.result b/mysql-test/suite/innodb_fts/r/innobase_create_after_drop_fts_index.result
new file mode 100644
index 00000000000..c3a30caa9dc
--- /dev/null
+++ b/mysql-test/suite/innodb_fts/r/innobase_create_after_drop_fts_index.result
@@ -0,0 +1,22 @@
+CREATE TABLE documents (
+FTS_DOC_ID BIGINT UNSIGNED AUTO_INCREMENT NOT NULL PRIMARY KEY,
+id INT,
+title TEXT,
+body TEXT,
+summary TEXT
+) ENGINE=InnoDB;
+CREATE FULLTEXT INDEX idx1 ON documents (title);
+CREATE FULLTEXT INDEX idx2 ON documents (body);
+INSERT INTO documents (id, title, body, summary) VALUES
+(1, 'Title 1', 'This is the body of document 1', 'Summary of document 1'),
+(2, 'Title 2', 'This is the body of document 2', 'Summary of document 2'),
+(3, 'Title 3', 'This is the body of document 3', 'Summary of document 3'),
+(4, 'Title 4', 'This is the body of document 4', 'Summary of document 4'),
+(5, 'Title 5', 'This is the body of document 5', 'Summary of document 5'),
+(6, 'Title 6', 'This is the body of document 6', 'Summary of document 6'),
+(7, 'Title 7', 'This is the body of document 7', 'Summary of document 7'),
+(8, 'Title 8', 'This is the body of document 8', 'Summary of document 8'),
+(9, 'Title 9', 'This is the body of document 9', 'Summary of document 9'),
+(10, 'Title 10', 'This is the body of document 10', 'Summary of document 10');
+ALTER TABLE documents DROP INDEX idx1, DROP INDEX idx2, ADD FULLTEXT INDEX idx3(summary), ALGORITHM=INPLACE;
+DROP TABLE documents;
diff --git a/mysql-test/suite/innodb_fts/t/innobase_create_after_drop_fts_index.test b/mysql-test/suite/innodb_fts/t/innobase_create_after_drop_fts_index.test
new file mode 100644
index 00000000000..2d747390af9
--- /dev/null
+++ b/mysql-test/suite/innodb_fts/t/innobase_create_after_drop_fts_index.test
@@ -0,0 +1,37 @@
+# Test whether DROP all FTS indexes followed by
+# an ADD FTS index in the same transaction
+# causes any issues
+
+-- source include/have_debug.inc
+
+# Create a table with columns intended for FULLTEXT indexes
+CREATE TABLE documents (
+    FTS_DOC_ID BIGINT UNSIGNED AUTO_INCREMENT NOT NULL PRIMARY KEY,
+    id INT,
+    title TEXT,
+    body TEXT,
+    summary TEXT
+) ENGINE=InnoDB;
+
+# Create FULLTEXT indexes
+CREATE FULLTEXT INDEX idx1 ON documents (title);
+CREATE FULLTEXT INDEX idx2 ON documents (body);
+
+# Insert some data
+INSERT INTO documents (id, title, body, summary) VALUES
+    (1, 'Title 1', 'This is the body of document 1', 'Summary of document 1'),
+    (2, 'Title 2', 'This is the body of document 2', 'Summary of document 2'),
+    (3, 'Title 3', 'This is the body of document 3', 'Summary of document 3'),
+    (4, 'Title 4', 'This is the body of document 4', 'Summary of document 4'),
+    (5, 'Title 5', 'This is the body of document 5', 'Summary of document 5'),
+    (6, 'Title 6', 'This is the body of document 6', 'Summary of document 6'),
+    (7, 'Title 7', 'This is the body of document 7', 'Summary of document 7'),
+    (8, 'Title 8', 'This is the body of document 8', 'Summary of document 8'),
+    (9, 'Title 9', 'This is the body of document 9', 'Summary of document 9'),
+    (10, 'Title 10', 'This is the body of document 10', 'Summary of document 10');
+
+
+# -- Drop the FULLTEXT indexes from the table and add another index
+ALTER TABLE documents DROP INDEX idx1, DROP INDEX idx2, ADD FULLTEXT INDEX idx3(summary), ALGORITHM=INPLACE;
+
+DROP TABLE documents;
diff --git a/storage/innobase/fts/fts0fts.cc b/storage/innobase/fts/fts0fts.cc
index b149cfcbd1b..f8cb740f285 100644
--- a/storage/innobase/fts/fts0fts.cc
+++ b/storage/innobase/fts/fts0fts.cc
@@ -813,17 +813,21 @@ fts_drop_index(
 /*===========*/
 	dict_table_t*	table,	/*!< in: Table where indexes are dropped */
 	dict_index_t*	index,	/*!< in: Index to be dropped */
-	trx_t*		trx)	/*!< in: Transaction for the drop */
+	trx_t*		trx,	/*!< in: Transaction for the drop */
+	bool		adding_another) /*! in: Another FTS index is to be
+                                            added as part of the same
+                                            transaction */
 {
 	ib_vector_t*	indexes = table->fts->indexes;
 	dberr_t		err = DB_SUCCESS;
 
 	ut_a(indexes);
 
-	if ((ib_vector_size(indexes) == 1
+	const bool last_index = (ib_vector_size(indexes) == 1
 	    && (index == static_cast<dict_index_t*>(
 			ib_vector_getp(table->fts->indexes, 0))))
-	   || ib_vector_is_empty(indexes)) {
+	   || ib_vector_is_empty(indexes);
+	if (last_index && !adding_another) {
 		doc_id_t	current_doc_id;
 		doc_id_t	first_doc_id;
 
diff --git a/storage/innobase/handler/handler0alter.cc b/storage/innobase/handler/handler0alter.cc
index 6f3c99c5871..194704744bb 100644
--- a/storage/innobase/handler/handler0alter.cc
+++ b/storage/innobase/handler/handler0alter.cc
@@ -1,6 +1,6 @@
 /*****************************************************************************
 
-Copyright (c) 2005, 2023, Oracle and/or its affiliates.
+Copyright (c) 2005, 2024, Oracle and/or its affiliates.
 
 This program is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License, version 2.0,
@@ -8210,12 +8210,17 @@ commit_cache_norebuild(
 		}
 	}
 
+	bool adding_fts_index = false;
+
 	for (ulint i = 0; i < ctx->num_to_add_index; i++) {
 		dict_index_t*	index = ctx->add_index[i];
 		assert(dict_index_get_online_status(index)
 		       == ONLINE_INDEX_COMPLETE);
 		assert(!index->is_committed());
 		index->set_committed(true);
+		if (index->type & DICT_FTS) {
+			adding_fts_index = true;
+		}
 	}
 
 	if (ctx->num_to_drop_index) {
@@ -8262,7 +8267,7 @@ commit_cache_norebuild(
 				       || (index->type
 					   & DICT_CORRUPT));
 				assert(index->table->fts);
-				fts_drop_index(index->table, index, trx);
+				fts_drop_index(index->table, index, trx, adding_fts_index);
 			}
 
 			dict_index_remove_from_cache(index->table, index);
@@ -9062,9 +9067,6 @@ foreign_fail:
 
 			if (index->type & DICT_FTS) {
 				assert(index->type == DICT_FTS);
-				/* We reset DICT_TF2_FTS here because the bit
-				is left unset when a drop proceeds the add. */
-				DICT_TF2_FLAG_SET(ctx->new_table, DICT_TF2_FTS);
 				fts_add_index(index, ctx->new_table);
 			}
 		}
diff --git a/storage/innobase/include/fts0fts.h b/storage/innobase/include/fts0fts.h
index 6059928e1d9..1279095a333 100644
--- a/storage/innobase/include/fts0fts.h
+++ b/storage/innobase/include/fts0fts.h
@@ -1,6 +1,6 @@
 /*****************************************************************************
 
-Copyright (c) 2011, 2023, Oracle and/or its affiliates.
+Copyright (c) 2011, 2024, Oracle and/or its affiliates.
 
 This program is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License, version 2.0,
@@ -1049,7 +1049,10 @@ fts_drop_index(
 /*===========*/
 	dict_table_t*	table,	/*!< in: Table where indexes are dropped */
 	dict_index_t*	index,	/*!< in: Index to be dropped */
-	trx_t*		trx);	/*!< in: Transaction for the drop */
+	trx_t*		trx,	/*!< in: Transaction for the drop */
+	bool		adding_another = false); /*!< in: Another FTS index is
+                                                      to be added as part of
+                                                      the same transaction */
 
 /****************************************************************//**
 Rename auxiliary tables for all fts index for a table

